<?xml version="1.0" encoding="UTF-8"?>
<beans xmlns="http://www.springframework.org/schema/beans"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:context="http://www.springframework.org/schema/context"
	xmlns:tx="http://www.springframework.org/schema/tx"
	xsi:schemaLocation="http://www.springframework.org/schema/beans https://www.springframework.org/schema/beans/spring-beans-4.3.xsd
		http://www.springframework.org/schema/context https://www.springframework.org/schema/context/spring-context-4.3.xsd
		http://www.springframework.org/schema/tx http://www.springframework.org/schema/tx/spring-tx-4.3.xsd">


	<beans>
		<!-- Create Data source bean -->
		<bean name="dataSource"
			class="org.springframework.jdbc.datasource.DriverManagerDataSource">
			<property name="driverClassName"
				value="com.mysql.cj.jdbc.Driver" />
			<property name="url"
				value="jdbc:mysql://localhost:3306/sh09" />
			<property name="username" value="root" />
			<property name="password" value="root" />
		</bean>

		<!-- LocalSessionFactoryBean is inherited from Session Factory class -->
		<bean id="sessionFactory"
			class="org.springframework.orm.hibernate5.LocalSessionFactoryBean">
			<property name="dataSource" ref="dataSource"></property>

			<!-- If we have hibernate.cfg.xml already available/created -->
			<property name="configLocation"
				value="classpath:hibernate.cfg.xml" />

			<!-- If we want to configure hibernate properties in this file only then 
				we have below option/syntax -->
			<!-- <property name="hibernateProperties"> <props> <prop key="hibernate.dialect"> 
				org.hibernate.dialect.MySQL8Dialect </prop> <prop key="hibernate.show_sql"> 
				true </prop> </props> </property> -->

			<!-- It will search for all classes annotated with @entity in package 
				com.cdac.entitie -->
			<property name="packagesToScan" value="com.cdac.entity" />
		</bean>

		<!-- Below bean will manage transaction i.e. it will begin transaction, 
			commit and rollback transaction -->
		<bean id="transactionManager"
			class="org.springframework.orm.hibernate5.HibernateTransactionManager">
			<property name="sessionFactory" ref="sessionFactory" />
		</bean>

		<!-- @Transactional annotation will work if and only if transaction management 
			is enable and below tag enables it -->
		<tx:annotation-driven
			transaction-manager="transactionManager" />
	</beans>

</beans>
